commit:     1b3873a2a9520117077eac956e7bfe6072f85ff7
Author:     Sam James <sam <AT> gentoo <DOT> org>
AuthorDate: Thu Jul 17 11:11:01 2025 +0000
Commit:     Sam James <sam <AT> gentoo <DOT> org>
CommitDate: Thu Jul 17 11:12:24 2025 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=1b3873a2

dev-python/numpy: fix regression breaking dev-python/vector tests

Bug: https://github.com/scikit-hep/vector/issues/616
Bug: https://github.com/numpy/numpy/issues/29388
Signed-off-by: Sam James <sam <AT> gentoo.org>

 .../numpy/files/numpy-2.3.1-fix-vector.patch       | 156 ++++++++++++++++
 dev-python/numpy/numpy-2.3.1-r1.ebuild             | 201 +++++++++++++++++++++
 2 files changed, 357 insertions(+)

diff --git a/dev-python/numpy/files/numpy-2.3.1-fix-vector.patch 
b/dev-python/numpy/files/numpy-2.3.1-fix-vector.patch
new file mode 100644
index 000000000000..0748bc5a1417
--- /dev/null
+++ b/dev-python/numpy/files/numpy-2.3.1-fix-vector.patch
@@ -0,0 +1,156 @@
+https://github.com/scikit-hep/vector/issues/616
+https://github.com/numpy/numpy/issues/29388
+https://github.com/numpy/numpy/pull/29392
+
+From d8eeb76d457a03347387c57ae7b84530aa38578d Mon Sep 17 00:00:00 2001
+From: Maanas Arora <[email protected]>
+Date: Wed, 16 Jul 2025 18:11:31 -0400
+Subject: [PATCH 1/5] BUG: update fast_scalar_power to handle special-case
+ squaring for any array type except object arrays
+
+---
+ numpy/_core/src/multiarray/number.c | 7 ++++++-
+ 1 file changed, 6 insertions(+), 1 deletion(-)
+
+diff --git a/numpy/_core/src/multiarray/number.c 
b/numpy/_core/src/multiarray/number.c
+index b801d7e041e2..8ab1d0d4a784 100644
+--- a/numpy/_core/src/multiarray/number.c
++++ b/numpy/_core/src/multiarray/number.c
+@@ -363,7 +363,12 @@ fast_scalar_power(PyObject *o1, PyObject *o2, int 
inplace, PyObject **result)
+     }
+ 
+     PyArrayObject *a1 = (PyArrayObject *)o1;
+-    if (!(PyArray_ISFLOAT(a1) || PyArray_ISCOMPLEX(a1))) {
++    if (PyArray_ISOBJECT(a1)) {
++        return 1;
++    }
++    if (!is_square && !PyArray_ISFLOAT(a1) && !PyArray_ISCOMPLEX(a1)) {
++        // we special-case squaring for any array type
++        // gh-29388
+         return 1;
+     }
+ 
+
+From 097b04a300e9bd5f35230a6450dbf7d939426dd3 Mon Sep 17 00:00:00 2001
+From: Maanas Arora <[email protected]>
+Date: Wed, 16 Jul 2025 18:19:04 -0400
+Subject: [PATCH 2/5] BUG: fix missing declaration
+
+---
+ numpy/_core/src/multiarray/number.c | 3 +++
+ 1 file changed, 3 insertions(+)
+
+diff --git a/numpy/_core/src/multiarray/number.c 
b/numpy/_core/src/multiarray/number.c
+index 8ab1d0d4a784..6b885ffa68e1 100644
+--- a/numpy/_core/src/multiarray/number.c
++++ b/numpy/_core/src/multiarray/number.c
+@@ -332,6 +332,8 @@ static int
+ fast_scalar_power(PyObject *o1, PyObject *o2, int inplace, PyObject **result)
+ {
+     PyObject *fastop = NULL;
++    int is_square = 0;
++
+     if (PyLong_CheckExact(o2)) {
+         int overflow = 0;
+         long exp = PyLong_AsLongAndOverflow(o2, &overflow);
+@@ -344,6 +346,7 @@ fast_scalar_power(PyObject *o1, PyObject *o2, int inplace, 
PyObject **result)
+         }
+         else if (exp == 2) {
+             fastop = n_ops.square;
++            is_square = 1;
+         }
+         else {
+             return 1;
+
+From 79a91a1bdaa50339ad513998c440b8949f15f56e Mon Sep 17 00:00:00 2001
+From: Maanas Arora <[email protected]>
+Date: Wed, 16 Jul 2025 18:29:08 -0400
+Subject: [PATCH 3/5] TST: add test to ensure `arr**2` calls square for
+ structured dtypes
+
+---
+ numpy/_core/tests/test_multiarray.py | 7 +++++++
+ 1 file changed, 7 insertions(+)
+
+diff --git a/numpy/_core/tests/test_multiarray.py 
b/numpy/_core/tests/test_multiarray.py
+index 04222025883e..364a9793a81f 100644
+--- a/numpy/_core/tests/test_multiarray.py
++++ b/numpy/_core/tests/test_multiarray.py
+@@ -4215,6 +4215,13 @@ def pow_for(exp, arr):
+         assert_equal(obj_arr ** -1, pow_for(-1, obj_arr))
+         assert_equal(obj_arr ** 2, pow_for(2, obj_arr))
+ 
++    def test_pow_calls_square_structured_dtype(self):
++        # gh-29388
++        dt = np.dtype([('a', 'i4'), ('b', 'i4')])
++        a = np.array([(1, 2), (3, 4)], dtype= dt)
++        with pytest.raises(TypeError, match="ufunc 'square' not supported"):
++            a ** 2
++
+     def test_pos_array_ufunc_override(self):
+         class A(np.ndarray):
+             def __array_ufunc__(self, ufunc, method, *inputs, **kwargs):
+
+From e014ffe34ee4573538691cd197273ff08f35d26b Mon Sep 17 00:00:00 2001
+From: Maanas Arora <[email protected]>
+Date: Wed, 16 Jul 2025 18:32:48 -0400
+Subject: [PATCH 4/5] STY: remove whitespace
+
+---
+ numpy/_core/tests/test_multiarray.py | 2 +-
+ 1 file changed, 1 insertion(+), 1 deletion(-)
+
+diff --git a/numpy/_core/tests/test_multiarray.py 
b/numpy/_core/tests/test_multiarray.py
+index 364a9793a81f..e7647d2e23fe 100644
+--- a/numpy/_core/tests/test_multiarray.py
++++ b/numpy/_core/tests/test_multiarray.py
+@@ -4218,7 +4218,7 @@ def pow_for(exp, arr):
+     def test_pow_calls_square_structured_dtype(self):
+         # gh-29388
+         dt = np.dtype([('a', 'i4'), ('b', 'i4')])
+-        a = np.array([(1, 2), (3, 4)], dtype= dt)
++        a = np.array([(1, 2), (3, 4)], dtype=dt)
+         with pytest.raises(TypeError, match="ufunc 'square' not supported"):
+             a ** 2
+ 
+
+From ddaef11f219990372f1c10bca2d3d3f0bb57a2e9 Mon Sep 17 00:00:00 2001
+From: Maanas Arora <[email protected]>
+Date: Thu, 17 Jul 2025 05:16:12 -0400
+Subject: [PATCH 5/5] BUG: replace new variable `is_square` with direct op
+ comparison in `fast_scalar_power` function
+
+---
+ numpy/_core/src/multiarray/number.c | 4 +---
+ 1 file changed, 1 insertion(+), 3 deletions(-)
+
+diff --git a/numpy/_core/src/multiarray/number.c 
b/numpy/_core/src/multiarray/number.c
+index 6b885ffa68e1..de4012641684 100644
+--- a/numpy/_core/src/multiarray/number.c
++++ b/numpy/_core/src/multiarray/number.c
+@@ -332,7 +332,6 @@ static int
+ fast_scalar_power(PyObject *o1, PyObject *o2, int inplace, PyObject **result)
+ {
+     PyObject *fastop = NULL;
+-    int is_square = 0;
+ 
+     if (PyLong_CheckExact(o2)) {
+         int overflow = 0;
+@@ -346,7 +345,6 @@ fast_scalar_power(PyObject *o1, PyObject *o2, int inplace, 
PyObject **result)
+         }
+         else if (exp == 2) {
+             fastop = n_ops.square;
+-            is_square = 1;
+         }
+         else {
+             return 1;
+@@ -369,7 +367,7 @@ fast_scalar_power(PyObject *o1, PyObject *o2, int inplace, 
PyObject **result)
+     if (PyArray_ISOBJECT(a1)) {
+         return 1;
+     }
+-    if (!is_square && !PyArray_ISFLOAT(a1) && !PyArray_ISCOMPLEX(a1)) {
++    if (fastop != n_ops.square && !PyArray_ISFLOAT(a1) && 
!PyArray_ISCOMPLEX(a1)) {
+         // we special-case squaring for any array type
+         // gh-29388
+         return 1;
+

diff --git a/dev-python/numpy/numpy-2.3.1-r1.ebuild 
b/dev-python/numpy/numpy-2.3.1-r1.ebuild
new file mode 100644
index 000000000000..1350cbc4fdbe
--- /dev/null
+++ b/dev-python/numpy/numpy-2.3.1-r1.ebuild
@@ -0,0 +1,201 @@
+# Copyright 1999-2025 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=8
+
+DISTUTILS_EXT=1
+DISTUTILS_USE_PEP517=meson-python
+PYTHON_COMPAT=( python3_{11..14} pypy3_11 )
+PYTHON_REQ_USE="threads(+)"
+FORTRAN_NEEDED=lapack
+
+inherit distutils-r1 flag-o-matic fortran-2 pypi
+
+DESCRIPTION="Fast array and numerical python library"
+HOMEPAGE="
+       https://numpy.org/
+       https://github.com/numpy/numpy/
+       https://pypi.org/project/numpy/
+"
+
+LICENSE="BSD"
+SLOT="0/2"
+KEYWORDS="~alpha ~amd64 ~arm ~arm64 ~hppa ~loong ~m68k ~mips ~ppc ~ppc64 
~riscv ~s390 ~sparc ~x86"
+# +lapack because the internal fallbacks are pretty slow. Building without blas
+# is barely supported anyway, see bug #914358.
+IUSE="big-endian +lapack"
+
+RDEPEND="
+       lapack? (
+               >=virtual/cblas-3.8
+               >=virtual/lapack-3.8
+       )
+"
+BDEPEND="
+       ${RDEPEND}
+       >=dev-build/meson-1.5.2
+       >=dev-python/cython-3.0.6[${PYTHON_USEDEP}]
+       lapack? (
+               virtual/pkgconfig
+       )
+       test? (
+               $(python_gen_cond_dep '
+                       >=dev-python/cffi-1.14.0[${PYTHON_USEDEP}]
+               ' 'python*')
+               dev-python/charset-normalizer[${PYTHON_USEDEP}]
+               >=dev-python/hypothesis-5.8.0[${PYTHON_USEDEP}]
+               dev-python/pytest-rerunfailures[${PYTHON_USEDEP}]
+               dev-python/pytest-timeout[${PYTHON_USEDEP}]
+               >=dev-python/pytz-2019.3[${PYTHON_USEDEP}]
+       )
+"
+
+QA_CONFIG_IMPL_DECL_SKIP=(
+       # https://bugs.gentoo.org/925367
+       vrndq_f32
+)
+
+EPYTEST_XDIST=1
+distutils_enable_tests pytest
+
+python_prepare_all() {
+       local PATCHES=(
+               # https://github.com/google/highway/issues/2577
+               # 
github.com/google/highway/commit/7cde540171a1718a9bdfa8f896d70e47eb0785d5
+               "${FILESDIR}/${PN}-2.2.6-gcc16.patch"
+               # https://github.com/numpy/numpy/pull/29392
+               "${FILESDIR}/${PN}-2.3.1-fix-vector.patch"
+       )
+
+       # bug #922457
+       filter-lto
+       # https://github.com/numpy/numpy/issues/25004
+       append-flags -fno-strict-aliasing
+
+       distutils-r1_python_prepare_all
+}
+
+python_configure_all() {
+       DISTUTILS_ARGS=(
+               -Dallow-noblas=$(usex !lapack true false)
+               -Dblas=$(usev lapack cblas)
+               -Dlapack=$(usev lapack lapack)
+               # TODO: cpu-* options
+       )
+}
+
+python_test() {
+       # don't run tests that require more than 2 GiB of RAM (per process)
+       local -x NPY_AVAILABLE_MEM="2 GiB"
+
+       local EPYTEST_DESELECT=(
+               # Very disk-and-memory-hungry
+               numpy/lib/tests/test_io.py::TestSavezLoad::test_closing_fid
+               
numpy/lib/tests/test_io.py::TestSavezLoad::test_closing_zipfile_after_load
+
+               # Precision problems
+               
numpy/_core/tests/test_umath_accuracy.py::TestAccuracy::test_validate_transcendentals
+
+               numpy/typing/tests/test_typing.py
+       )
+
+       if [[ $(uname -m) == armv8l ]]; then
+               # Degenerate case of arm32 chroot on arm64, bug #774108
+               EPYTEST_DESELECT+=(
+                       
numpy/_core/tests/test_cpu_features.py::Test_ARM_Features::test_features
+               )
+       fi
+
+       case ${ARCH} in
+               arm)
+                       EPYTEST_DESELECT+=(
+                               # TODO: warnings
+                               
numpy/_core/tests/test_umath.py::TestSpecialFloats::test_unary_spurious_fpexception
+
+                               # TODO
+                               
numpy/_core/tests/test_function_base.py::TestLinspace::test_denormal_numbers
+                               
numpy/f2py/tests/test_kind.py::TestKind::test_real
+                               
numpy/f2py/tests/test_kind.py::TestKind::test_quad_precision
+
+                               # require too much memory
+                               
'numpy/_core/tests/test_multiarray.py::TestDot::test_huge_vectordot[complex128]'
+                               
'numpy/_core/tests/test_multiarray.py::TestDot::test_huge_vectordot[float64]'
+                       )
+                       ;;
+               hppa)
+                       EPYTEST_DESELECT+=(
+                               # https://bugs.gentoo.org/942689
+                               
"numpy/_core/tests/test_dtype.py::TestBuiltin::test_dtype[int]"
+                               
"numpy/_core/tests/test_dtype.py::TestBuiltin::test_dtype[float]"
+                               
"numpy/_core/tests/test_dtype.py::TestBuiltin::test_dtype_bytes_str_equivalence[datetime64]"
+                               
"numpy/_core/tests/test_dtype.py::TestBuiltin::test_dtype_bytes_str_equivalence[timedelta64]"
+                               
"numpy/_core/tests/test_dtype.py::TestBuiltin::test_dtype_bytes_str_equivalence[<f]"
+                               
"numpy/_core/tests/test_dtype.py::TestPickling::test_pickle_dtype[dt28]"
+                               
numpy/f2py/tests/test_kind.py::TestKind::test_real
+                               
numpy/f2py/tests/test_kind.py::TestKind::test_quad_precision
+                               
numpy/tests/test_ctypeslib.py::TestAsArray::test_reference_cycles
+                               
numpy/tests/test_ctypeslib.py::TestAsArray::test_segmentation_fault
+                               
numpy/tests/test_ctypeslib.py::TestAsCtypesType::test_scalar
+                               
numpy/tests/test_ctypeslib.py::TestAsCtypesType::test_subarray
+                               
numpy/tests/test_ctypeslib.py::TestAsCtypesType::test_structure
+                               
numpy/tests/test_ctypeslib.py::TestAsCtypesType::test_structure_aligned
+                               
numpy/tests/test_ctypeslib.py::TestAsCtypesType::test_union
+                               
numpy/tests/test_ctypeslib.py::TestAsCtypesType::test_padded_union
+                       )
+                       ;;
+               ppc|x86)
+                       EPYTEST_DESELECT+=(
+                               # require too much memory
+                               
'numpy/_core/tests/test_multiarray.py::TestDot::test_huge_vectordot[complex128]'
+                               
'numpy/_core/tests/test_multiarray.py::TestDot::test_huge_vectordot[float64]'
+                       )
+                       ;;
+       esac
+
+       if [[ ${CHOST} == powerpc64le-* ]]; then
+               EPYTEST_DESELECT+=(
+                       # long double thingy
+                       
numpy/_core/tests/test_scalarprint.py::TestRealScalars::test_ppc64_ibm_double_double128
+               )
+       fi
+
+       if use big-endian; then
+               EPYTEST_DESELECT+=(
+                       # ppc64 and sparc
+                       
numpy/linalg/tests/test_linalg.py::TestDet::test_generalized_sq_cases
+                       
numpy/linalg/tests/test_linalg.py::TestDet::test_sq_cases
+                       
"numpy/f2py/tests/test_return_character.py::TestFReturnCharacter::test_all_f77[s1]"
+                       
"numpy/f2py/tests/test_return_character.py::TestFReturnCharacter::test_all_f77[t1]"
+                       
"numpy/f2py/tests/test_return_character.py::TestFReturnCharacter::test_all_f90[s1]"
+                       
"numpy/f2py/tests/test_return_character.py::TestFReturnCharacter::test_all_f90[t1]"
+               )
+       fi
+
+       if ! has_version -b "~${CATEGORY}/${P}[${PYTHON_USEDEP}]" ; then
+               # depends on importing numpy.random from system namespace
+               EPYTEST_DESELECT+=(
+                       'numpy/random/tests/test_extending.py::test_cython'
+               )
+       fi
+
+       if has_version ">=dev-python/setuptools-74[${PYTHON_USEDEP}]"; then
+               # msvccompiler removal
+               EPYTEST_DESELECT+=(
+                       
numpy/tests/test_public_api.py::test_all_modules_are_expected_2
+                       numpy/tests/test_public_api.py::test_api_importable
+               )
+               EPYTEST_IGNORE+=(
+                       numpy/distutils/tests/test_mingw32ccompiler.py
+                       numpy/distutils/tests/test_system_info.py
+               )
+       fi
+
+       local -x PYTEST_DISABLE_PLUGIN_AUTOLOAD=1
+       cd "${BUILD_DIR}/install$(python_get_sitedir)" || die
+       epytest -p rerunfailures --reruns=5
+}
+
+python_install_all() {
+       local DOCS=( LICENSE.txt README.md THANKS.txt )
+       distutils-r1_python_install_all
+}

Reply via email to